<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo T1<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Somos el grupo T1, los autores son: Laura Fernández Corredera, Marcos Yedres Pérez, Álvaro Sánchez Yuste, Junior Chunga Cartagena y 
				Cristina Elena Dascalu</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>La URL del proyecto "TG3" en GitLab es: 
				<a href="https://gitlab.com/dte2020/t1/tg3/">https://gitlab.com/dte2020/t1/tg3/</a>.</p>
			<h3>1.3 Burndown chart</h3>
			<p>Imagen del diagrama Burndown final del Sprint TG3.</p>
			<img src="burndown.PNG" width="1280" height="720">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>En este apartado incluimos el enlace al archivo de la presentacion con diapositivas, ubicado en el
				repositorio del proyecto.</p>
			<a href="presentacion.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<p>En este apartado se recogeran todos los requisitos para la realización de la app, que en nuestro caso será una calculadora.</p>
			<h3>2.1 Catálogo de requisitos</h3>
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>01. Única pantalla</td>
					<td>La aplicación deberá contar con una única pantalla en la que se realicen todas las operaciones.</td>
				</tr>
				<tr>
					<td>02. Mostrar Números</td>
					<td>La pantalla deberá mostrar todos los números en la misma para que el usuario pueda seleccionarlos.</td>
				</tr>
				<tr>
					<td>03. Decimales.</td>
					<td>Los números pueden ser decimales, para ello se debe poder añadir un punto al número para que este no tenga por que ser entero y aquellos números que se selecciones tras el punto sean los decimales del número previo al punto</td>
				</tr>
				<tr>
					<td>04. Mínimo de números decimales.</td>
					<td>Se requiere que al menos se puedan usar 3 números en los decimales</td>
				</tr>
				<tr>
					<td>05. Números negativos.</td>
					<td>Un número podrá ser negativo al seleccionarlo si se selecciona el botón de resta previamente a seleccionar dicho número.</td>
				</tr>
				<tr>
					<td>06. Mostrar operandos. </td>
					<td>La pantalla deberá mostrar todos los operandos en la misma pantalla indicada en el primer requisito, de forma que al seleccionar el número posteriormente pueda seleccionar la operación.</td>
				</tr>
				<tr>
					<td>07. Botón “=”.</td>
					<td>En la pantalla aparecerá un botón que contendrá “=” y servirá para que al pulsarlo se realice el cálculo solicitado por el usuario.</td>
				</tr>
				<tr>
					<td>08. Botón reseteo. </td>
					<td>En la pantalla debe haber un botón que al presionarlo resetee el valor de los datos  que ha volcado el usuario, es decir, que los borre.</td>
				</tr>
				<tr>
					<td>09. Finalización errónea.</td>
					<td>Si el usuario desea conocer el resultado pero no ha rellenado los campos pertinentes necesarios que no devuelva nada o error.</td>
				</tr>
				<tr>
					<td>10. Prioridad número.</td>
					<td>Para el correcto funcionamiento de la aplicación se debe seleccionar primero un número, después la operación a realizar y por último el otro número.</td>
				</tr>
				<tr>
					<td>11. Cálculo de más números.</td>
					<td>El programa solo opera con dos números, por lo cual salvo que se presione “=” si el usuario pulsa otro botón de operación tras hacer una previa se calculará el resultado y se usará para la siguiente operación.</td>
				</tr>
				<tr>
					<td>12. Mostrar selecciones.</td>
					<td>A medida que el usuario seleccione por pantalla esto se deberá mostrar por pantalla, es decir, que vea lo que el ha seleccionado.</td>
				</tr>
				<tr>
					<td>13. Mostrar resultado.</td>
					<td>La aplicación mostrará el resultado por pantalla dando por finalizado una operación cuando el usuario pulse “=”.</td>
				</tr>
				<tr>
					<td>14. Tiempo resultado.</td>
					<td>El sistema debe tardar menos de dos segundos en volcar el resultado.</td>
				</tr>
				<tr>
					<td>15. Sumar.</td>
					<td>Una de las operaciones que debe realizar el sistema es sumar dos números.</td>
				</tr>
				<tr>
					<td>16. Restar.</td>
					<td>Una de las operaciones que debe realizar el sistema es restar dos números.</td>
				</tr>
				<tr>
					<td>17. Multiplicar.</td>
					<td>Una de las operaciones que debe realizar el sistema es multiplicar dos números.</td>
				</tr>
				<tr>
					<td>18. Dividir.</td>
					<td>. Una de las operaciones que debe realizar el sistema es dividir dos números.</td>
				</tr>
				<tr>
					<td>19. Funcionar en Android.</td>
					<td>La aplicación deberá poder ser usada en Android.</td>
				</tr>
				<tr>
					<td>20. Funcionar en IOS.</td>
					<td>La aplicación deberá poder ser usada en IOS.</td>
				</tr>
			</table>
		</section>

		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>
			<p>En el trabajo TG2 se definieron criterios de comparación de las dos tecnologías a nivel teórico.</p>
			<p>En este trabajo hay que definir criterios para la comparación de la implementación de las tecnologías en
				la construcción de los prototipos, cuyos requisitos son los establecidos en el apartado 2.</p>
			<p>Se trata de criterios del tipo “horas empleadas en el desarrollo del sistema”, “velocidad de
				funcionamiento del sistema”, “recursos necesarios”, etc.</p>
			<h4>3.1 Criterio 1: Tiempo de desarrollo </h4>
                <ul>
                    <li>Nombre del criterio: Tiempo de desarrollo</li>
                    <li>Descripcion: Tiempo total que han tardado los desarrolladores en crear la apliación</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	
				
			<h4>3.2 Criterio 2: Nº de líneas de código</h4>
                <ul>
                    <li>Nombre del criterio: Nº de líneas de código</li>
                    <li>Descripcion: Cantidad total de líneas de código que forman la aplicación</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	

			<h4>3.3 Criterio 3: Nº de herramientas utilizadas </h4>
                <ul>
                    <li>Nombre del criterio: Nº de herramientas utilizadas</li>
                    <li>Descripcion: Cantidad de herramientas necesarias para desarrollar las aplicaciones, desde escribir el código hasta ejecutarlas</li>
                    <li>Tipo de valor: Numérico</li>
				</ul>
			<h4>3.4 Criterio 4: Nº de funciones </h4>
                <ul>
                    <li>Nombre del criterio: Nº de funciones</li>
                    <li>Descripcion: Nº total de funciones que tiene la aplicación</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	

			<h4>3.5 Criterio 5: Uso de recursos </h4>
                <ul>
                    <li>Nombre del criterio: Uso de recursos</li>
                    <li>Descripcion: Cantidad de recursos que utiliza la aplicación para poder ejecutarse</li>
					<li>Tipo de valor: Texto libre</li>
				</ul>	

			<h4>3.6 Criterio 6: Facilidad de desarrollo </h4>
                <ul>
                    <li>Nombre del criterio: Facilidad de desarrollo</li>
                    <li>Descripcion: Dificultad que ha supuesto el desarrollo de la aplicación para los programadores </li>
					<li>Tipo de valor: Texto libre  </li>
				</ul>	
				
			<h4>3.7 Criterio 7: Tiempo de aprendizaje para el desarrollo </h4>
                <ul>
                    <li>Nombre del criterio: Tiempo de aprendizaje para el desarrollo</li>
                    <li>Descripcion: Tiempo necesario para poder adaptarse a los diferentes entornos necesarios para realizar el desarrollo de las aplicaciones</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	

			<h4>3.8 Criterio 8: Usabilidad </h4>
                <ul>
                    <li>Nombre del criterio: Usabilidad</li>
                    <li>Descripcion: Capacidad que van a tener los usuarios para poder utilizar las aplicaciones </li>
					<li>Tipo de valor: Texto libre</li>
				</ul>	

			<h4>3.9 Criterio 9: Diseño de la interfaz </h4>
                <ul>
                    <li>Nombre del criterio: Diseño de la interfaz</li>
                    <li>Descripcion: Valoración de las diferentes interfaces que serán la cara visible de la aplicación hacia el usuario</li>
					<li>Tipo de valor: Texto libre</li>
				</ul>	

			<h4>3.10 Criterio 10: Facilidad de utilización </h4>
                <ul>
                    <li>Nombre del criterio: Facilidad de utilización</li>
                    <li>Descripcion: Capacidad que tendrán los usuarios para utilizar la aplicación de manera simple</li>
					<li>Tipo de valor: Texto libre </li>
				</ul>	

			<h4>3.11 Criterio 11: Peso de la aplicación </h4>
                <ul>
                    <li>Nombre del criterio: Peso de la aplicación</li>
                    <li>Descripcion: Tamaño de la aplicación</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	

			<h4>3.12 Criterio 12: Rapidez de la simulación </h4>
                <ul>
					<li>Nombre del criterio: Rapidez de la simulación</li>
					<li>Descripcion: Velocidad que tiene la simulación en los diferentes simuladores utilizados</li>
					<li>Tipo de valor: Numérico</li>
				</ul>	

		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con React Native </h2>
			<p>
			
				<a
					href="https://gitlab.com/dte2020/t1/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/t1/tg3/-/tree/master/prototipo-A/</a>.
			</p>
			<p>El prototipo se encuentra en la carpeta del Prototipo A incluyendo el manual de usuario.</p>

		
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con Flutter</h2>
			<p>Aquí se encuentra todo el código del proyecto desarrollado.
				<a
					href="https://gitlab.com/dte2020/t1/tg3/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/t1/tg3/-/tree/master/prototipo-B/</a>.
			</p>
			<p>En esta carpeta se incluye el código de la aplicación hecha en lenguaje Dart del Framework Flutter,
			y el manual de usuario, en el que se explica la instalación de los recursos para el desarrollo de la apliación y el uso de ésta.</p>

		</section>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
            <p>Debe incluir al menos una tabla resumen cruzando los criterios y los
                valores de cada tecnología. Con una columna de comentarios sobre la comparación.</p>
            <table>
                <tr>
                    <th>Criterio</th>
                    <th>Prototipo React Native</th>
                    <th>Prototipo Flutter</th>
                    <th>Comentarios</th>

                </tr>
                <tr>
                    <td>Tiempo de desarrollo</td>
                    <td>10 horas</td>
                    <td>2 días y medio</td>
                    <td>Observamos como las horas de desarrollo han sido bastante más en flutter que en React Native, esto se debe principalmente al lenguaje Dart del cual no se tenían concimientos</td>
                </tr>
                <tr>
                    <td>Líneas de código</td>
                    <td>214 líneas</td>
                    <td>239 líneas</td>
                    <td>Prácticamente tienen el mismo número de líneas</td>
                </tr>
                <tr>
                    <td>Nº de herramientas utilizadas</td>
                    <td>3 herramientas</td>
                    <td>4 herramientas</td>
                    <td>El número de herramientas es bastante parecidos</td>
                </tr>
                <tr>
                    <td>Nº de funciones</td>
                    <td>9 funciones</td>
                    <td>1 función</td>
                    <td>Destaca la diferencia que hay en el desarrollo en la manera de programar, y por esto hay tanta diferencia en la funciones</td>
                </tr>
                <tr>
                    <td>Uso de recursos</td>
                    <td>3 recursos</td>
                    <td>2 recuros</td>
                    <td>React Native: Expo y genymotion y swisscalc
						Flutter: Simuladores y plugins</td>
                </tr>
                <tr>
                    <td>Facilidad de desarrollo</td>
                    <td>Media</td>
                    <td>Media</td>
                    <td>React Native: Dificultad con el emilador SDK
						Flutter: Programación Dart</td>
                </tr>
                <tr>
                    <td>Tiempo de aprendizaje para el desarrollo</td>
                    <td>3 horas</td>
                    <td>1 día</td>
                    <td>Como vemos hay una diferencia en el tiempo debido a la diferencia en el lenguaje de programación. </td>
                </tr>
                <tr>
                    <td>Usabilidad</td>
                    <td>Alta</td>
                    <td>Alta</td>
                    <td>La utilidad de la aplicación es muy intuitiva y fácil de utilizar</td>
                </tr>
                <tr>
                    <td>Diseño de la interfaz</td>
                    <td>Intuitivo, y fácil para todo el mundo</td>
                    <td>Intuitivo, y fácil para todo el mundo</td>
                    <td>Es prácticamente el mismo en ambos casos</td>
                </tr>
                <tr>
                    <td>Facilidad de utilización</td>
                    <td>Muy sencillo</td>
                    <td>Muy sencillo</td>
                    <td>Al ser una calculadora, la aplicación en sí es bastante simple.</td>
                </tr>
                <tr>
                    <td>Peso de la aplicación</td>
                    <td>256 mb </td>
                    <td>1 gb </td>
                    <td>Podemos observar como la aplicación de flutter ocupa algo más que la de React Native.</td>
                </tr>
                <tr>
                    <td>Rapidez de la simulación</td>
                    <td>1 min arranque, 1 seg respuesta</td>
                    <td>Velocidad media</td>
                    <td>Podemos observar que la velocidad es lo normal en aplicaciones de este tipo.</td>
                </tr>
            </table>

		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>Como conclusión tras haber realizado el trabajo y ambos prototipos podríamos ir recogiendo diversos factores, 
				como puede ser la relevancia del conocimiento del lenguaje implementado pues influye mucho en el tiempo de desarrollo,
				y en nuestro caso, por ejemplo , marcó la diferencia, es por ello por lo que por ese lado no habría un ganador objetivo.
				Por otro lado, si nos enfocáramos en las líneas de código o de recursos, u otros muchos parámetros observamos que ofrecen
				muchas cosas muy similares entre ambos, por ello nos podríamos decantar quizá por Flutter si hablamos de rendimiento 
				puro y duro de la aplicación o por React native en cuanto a facilidades para nuestro desarrollo o tamaño de la aplicación,
				destacar que no porque haya una gran diferencia de complejidad entre ambos si no por la ya mencionada familiaridad del 
				lenguaje. Como última conclusión queremos recalcar que para nosotros ha sido una herramienta más sólida y práctica 
				React native que Flutter. Aunque por otro lado hemos visto que ambas herramientas son altamente útiles para cualquier 
				desarrollador de aplicaciones móviles hoy en día permitiendo ahorrar mucho tiempo y coste a la hora de su programación
				y que estas herramientas están lejos de ser difíciles de manejar pese a la profundidad que nos aportan.</p>
		</section>

		

	</main>

</body>

</html>